# Do not edit, this is file generated by m4 from Makefile.m4 and 
#  copied to the simulations while installation! 
# Make your changes in Makefile.conf.
#  E.g. add there files to compile or custom libs and so on.

# File:       Makefile for lpzrobots simulations
# Author:     Georg Martius  <georg.martius at web.de>
# Date:       Oct 2009

define(`COMMENT', )
COMMENT(`There are defines for platform dependend stuff.')
COMMENT(`DEV only produces output in the development version')
COMMENT(`DEVORUSER  choice between development (first argument) or user (second)')
COMMENT(`LINUXORMAC outputs the first argument on linux and the second on mac.')

ifdef(`DEVEL', 
`define(`DEVORUSER', $1) define(`DEV', $1)'
,
`define(`DEVORUSER', $2) define(`DEV',)'
)
ifdef(`MAC', 
`define(`LINUXORMAC', $2)'
,
`define(`LINUXORMAC', $1)'
)

EXEC = start
# add files to compile in the conf file
include Makefile.conf

EXEC_OPT  = $(EXEC)_opt
EXEC_DBG  = $(EXEC)_dbg
EXEC_PROF = $(EXEC)_prof

CFILES = $(addsuffix .cpp, $(FILES))
OFILES = $(addsuffix .o, $(FILES))

ODEROBOTSLIB := ode_robots
ODEROBOTSLIB_DBG := ode_robots_dbg
ODEROBOTSLIB_OPT := ode_robots_opt
ODEROBOTSLIB_PROF := ode_robots_prof
DEV(LIBODEROBOTS = $(ODEROBOTS)/lib$(ODEROBOTSLIB).a)

SELFORGLIB = selforg
SELFORGLIB_DBG = selforg_dbg
SELFORGLIB_OPT = selforg_opt
DEV(LIBSELFORG      = $(SELFORG)/lib$(SELFORGLIB).a)

GA_TOOLSLIB = ga_tools
GA_TOOLSLIB_OPT = ga_tools_opt
DEV(LIBGA_TOOLS = $(GA_TOOLS)/lib$(GA_TOOLSLIB).a)


ODELIBS = $(shell ode-dbl-config --libs)
GSLLIBS = $(shell gsl-config --libs)

LIBS  += -lm \
	DEV(-L$(ODEROBOTS)) -l$(ODEROBOTSLIB) \
	DEV(-L$(GA_TOOLS))  -l$(GA_TOOLSLIB) \
	DEV(-L$(SELFORG))   -l$(SELFORGLIB) \
	 $(ODELIBS) $(GSLLIBS) \
	-losgShadow -losgText -losgUtil -losgViewer -losgGA -lOpenThreads -losg -lGL -lGLU -lglut \
	-lreadline -lncurses -lpthread $(ADDITIONAL_LIBS)

INC   += -I. DEV(-I$(ODEROBOTS)/include -I$(GA_TOOLS)/include -I$(SELFORG)/include) LINUXORMAC(,-I/opt/local/include
)

CXX = g++
ODEFLAGS = $(shell ode-dbl-config --cflags)
CPPBASEFLAGS = $(ODEFLAGS) -pthread $(INC) -Wno-deprecated -Wall -fstack-protector -Wstack-protector
# -pg for profiling
CPPFLAGS = $(CPPBASEFLAGS) -g -O1
## Optimisation
CPPFLAGS_DBG = $(CPPBASEFLAGS) -g
## Optimisation
CPPFLAGS_OPT = $(CPPBASEFLAGS) -O3 -DNDEBUG

normal: DEV(libode_robots     libga_tools) $(EXEC)
opt:    DEV(libode_robots_opt libga_tools_opt) $(EXEC_OPT)
dbg:    DEV(libode_robots_dgb libga_tools_dgb) $(EXEC_DBG)
prof:   DEV(libode_robots     libga_tools_prof) $(EXEC_PROF)

$(EXEC): Makefile Makefile.depend $(OFILES) DEV($(LIBODEROBOTS) $(LIBSELFORG) $(LIBGA_TOOLS))
	$(CXX) $(CPPFLAGS) $(OFILES) $(LIBS) -o $(EXEC)

$(EXEC_OPT): ODEROBOTSLIB = $(ODEROBOTSLIB_OPT)
$(EXEC_OPT): GA_TOOLSLIB = $(GA_TOOLSLIB_OPT)
$(EXEC_OPT): SELFORGLIB = $(SELFORGLIB_OPT)
$(EXEC_OPT): CPPFLAGS = $(CPPFLAGS_OPT)
$(EXEC_OPT): Makefile Makefile.depend $(OFILES) DEV($(LIBODEROBOTS) $(LIBSELFORG) $(LIBGA_TOOLS))
	$(CXX) $(CPPFLAGS) $(OFILES) $(LIBS) -o $(EXEC_OPT)

$(EXEC_DBG): ODEROBOTSLIB = $(ODEROBOTSLIB_DBG)
$(EXEC_DBG): GA_TOOLSLIB = $(GA_TOOLSLIB_DBG)
$(EXEC_DBG): SELFORGLIB = $(SELFORGLIB_DBG)
$(EXEC_DBG): CPPFLAGS = $(CPPFLAGS_DBG)
$(EXEC_DBG): Makefile Makefile.depend $(OFILES) DEV($(LIBODEROBOTS) $(LIBSELFORG) $(LIBGA_TOOLS))
	$(CXX) $(CPPFLAGS) $(OFILES) $(LIBS) -o $(EXEC_DBG)

$(EXEC_PROF): ODEROBOTSLIB = $(ODEROBOTSLIB_PROF)
$(EXEC_PROF): Makefile Makefile.depend $(OFILES) DEV($(LIBODEROBOTS))
	$(CXX) $(CPPFLAGS) $(OFILES) $(LIBS) -o $(EXEC_PROF)

DEV(
libode_robots:	
	cd $(ODEROBOTS) && $(MAKE)

libode_robots_dbg:	
	cd $(ODEROBOTS) && $(MAKE) dbg

libode_robots_opt:	
	cd $(ODEROBOTS) && $(MAKE) opt

libode_robots_prof:	
	cd $(ODEROBOTS) && $(MAKE) prof

libga_tools:	
	cd $(GA_TOOLS) && $(MAKE)

libga_tools_opt:	
	cd $(GA_TOOLS) && $(MAKE) opt

libga_tools_dbg:	
	cd $(GA_TOOLS) && $(MAKE) dbg

libga_tools_prof:	
	cd $(GA_TOOLS) && $(MAKE) prof
)

Makefile.depend: 
	makedepend $(CFLAGS) $(INC) $(CFILES) -f- > Makefile.depend 2>/dev/null

depend: 
	makedepend $(CFLAGS) $(INC) $(CFILES)  -f- > Makefile.depend 2>/dev/null

tags: 
	etags $(find -name "*.[ch]")

clean-all: clean
	cd $(ODEROBOTS) && make clean-all
	cd $(SELFORG) && make clean-all

clean:
	rm -f $(EXEC) $(EXEC_DBG) $(EXEC_OPT) $(EXEC_PROF) *.o Makefile.depend

-include Makefile.depend
